/******************************************************************************
*******************************************************************************
**                                                                           **
**      C Swing - A graphical file and directory maintenance utility         **
**                                                                           **
*******************************************************************************
**                                                                           **
**      Original C coding by: S. J. Brown                                    **
**                                                                           **
**      Modifications by many others; see the documentation for a list       **
**                                                                           **
**      Copyright 1994, Harry Flowers and Foteos Macrides                    **
**                                                                           **
**      Terms of Copyright:  This software may be freely distributed         **
**          and used by anyone, providing the distributor provides it        **
**          free of charge or at a price which only covers distribution      **
**          costs.  It may not be sold.  Note that versions prior to         **
**          V3.7.4 were public domain, and are not subject to these terms.   **
**                                                                           **
**      Disclaimer: No warranties as to the use or reliability of this       **
**          software are given by the authors or distributors.  Use at       **
**          your own risk.                                                   **
**                                                                           **
*******************************************************************************
******************************************************************************/
 
/*
**  swing_11
**
**  display panic message in a little box in the middle of the screen
**  and get the user to acknowledge the error
*/
#include <stdio.h>
#include <smgdef.h>
#include <ssdef.h>
#include "more_descrip.h"
#include "swing.h"
#include "swing_refs.h"

#define PANIC_ROWS	11
#define PANIC_COLUMNS	40
#define PANIC_X		20
#define PANIC_Y		7

panic(code,text,where)
int code;
char *text, *where;
{
    int status,i;
    int display_panic;

    if (panicked_already)
        return(FALSE);

    panicked_already = TRUE;

    exit_error = code;

    smg$end_pasteboard_update(&paste);

    status = smg$create_virtual_display(&PANIC_ROWS,
                                        &PANIC_COLUMNS,
                                        &display_panic,
                                        &SMG$M_BORDER);
    if (status != SS$_NORMAL)
        goto plain_text;

    /*
    **  we want to wipe out this display, because it may be pasted over
    **  info put to the screen other than by smgs, and we don't want to
    **  change this - ideally we want repaint display, but we don't have 
    **  this, so we'll do it by hand
    */
    smg$set_cursor_abs(&display_panic,&1,&1);
    for (i = 0; i < PANIC_ROWS; i++)
        smg$put_line(&display_panic,DSC1(""));

    status = smg$erase_display(&display_panic);
    if (status != SS$_NORMAL)
        goto plain_text;

    status = smg$paste_virtual_display(&display_panic, &paste,
                                       &PANIC_Y, &PANIC_X);
    if (status != SS$_NORMAL)
        goto plain_text;

    smg$set_cursor_abs(&display_panic,&1,&1);
    smg$put_line(&display_panic,DSC1("? PANIC - FAULTY GOODS ?"));

    sprintf(junk,"Error %d - %08x",code,code);
    smg$put_line(&display_panic,DSC1(junk));
    smg$put_line(&display_panic,DSC1(where),0,0,0,&1);
    smg$put_line(&display_panic,DSC1(text),0,0,0,&1);
    smg$put_line(&display_panic,DSC1(full_error_text(code)),0,0,0,&1);
    smg$put_line(&display_panic,DSC1(""));
    smg$put_line(&display_panic,DSC1(PRESS_TO_CONTINUE));
    get_key(NO_AUTO);
    exit(code);

plain_text:
    puts("!! panic !!");
    if (code != SS$_NORMAL)
        printf("error code %d\n",code);
    puts(where);
    puts(text);
    sleep(5);
    exit(code);
}

